# -*- mode: ruby -*-
# vi: set ft=ruby :
require 'yaml'

custom_file_path = File.join(__dir__, (ENV['SYSCONFIG'] || 'custom.yaml'))

context = (File.exist?(custom_file_path)?YAML::load_file(custom_file_path):{}) || {}

# All Vagrant configuration is done below. The "2" in Vagrant.configure
# configures the configuration version (we support older styles for
# backwards compatibility). Please don't change it unless you know what
# you're doing.
Vagrant.configure(2) do |config|
  # The most common configuration options are documented and commented below.
  # For a complete reference, please see the online documentation at
  # https://docs.vagrantup.com.

  # Every Vagrant development environment requires a box. You can search for
  # boxes at https://atlas.hashicorp.com/search.
  #config.vm.box = "centos/7"
  config.vm.box = "puppetlabs/centos-7.0-64-nocm"

  # Disable automatic box update checking. If you disable this, then
  # boxes will only be checked for updates when the user runs
  # `vagrant box outdated`. This is not recommended.
  # config.vm.box_check_update = false

  # Create a private network, which allows host-only access to the machine
  # using a specific IP.
  # config.vm.network "private_network", ip: "192.168.33.10"
  config.vm.network :private_network, ip: (ENV['VM_IP'] || context['vm_ip'] || "172.16.1.6")
#  config.vm.network :private_network, ip: (ENV['VM_IP'] || context['vm_ip'] || "172.16.1.6"), virtualbox__intnet: true, adapter: "1"
#  config.vm.network :private_network, ip: (ENV['VM_IP'] || context['vm_ip'] || "172.16.1.6"), virtualbox__intnet: true

  # Create a forwarded port mapping which allows access to a specific port
  # within the machine from a port on the host machine. In the example below,
  # accessing "localhost:8080" will access port 80 on the guest machine.
  # config.vm.network "forwarded_port", guest: 80, host: 8080
  default_ports = {
    80   => 40000,
    22   => 22220,
    443  => 44300,
    3306 => 33060,
    5432 => 54320,
    8080 => 40400,
  }

  # Use Default Port Forwarding Unless Overridden
  default_ports.each do |guest, host|
    config.vm.network "forwarded_port", guest: guest, host: host
  end

  # Create a public network, which generally matched to bridged network.
  # Bridged networks make the machine appear as another physical device on
  # your network.
  # config.vm.network "public_network"

  # Share an additional folder to the guest VM. The first argument is
  # the path on the host to the actual folder. The second argument is
  # the path on the guest to mount the folder. And the optional third
  # argument is a set of non-required options.
  # config.vm.synced_folder "../data", "/vagrant_data"
  # config.vm.synced_folder "../server/src", "/var/www/corpus", id: "code-root",
  #   owner: "vagrant",
  #   group: 498,
  #   mount_options: ["dmode=775,fmode=664"]
  config.vm.synced_folder ".", "/vagrant", type: "virtualbox"


  # Provider-specific configuration so you can fine-tune various
  # backing providers for Vagrant. These expose provider-specific options.
  # Example for VirtualBox:
  #
  # config.vm.provider "virtualbox" do |vb|
  #   # Display the VirtualBox GUI when booting the machine
  #   vb.gui = true
  #
  #   # Customize the amount of memory on the VM:
  #   vb.memory = "1024"
  # end
  config.vm.provider "virtualbox" do |v|
    v.memory = 1536
    v.customize ["modifyvm", :id, "--natdnshostresolver1", "on"]
  end

  #
  # View the documentation for the provider you are using for more
  # information on available options.

  # Define a Vagrant Push strategy for pushing to Atlas. Other push strategies
  # such as FTP and Heroku are also available. See the documentation at
  # https://docs.vagrantup.com/v2/push/atlas.html for more information.
  # config.push.define "atlas" do |push|
  #   push.app = "YOUR_ATLAS_USERNAME/YOUR_APPLICATION_NAME"
  # end

  # Enable provisioning with a shell script. Additional provisioners such as
  # Puppet, Chef, Ansible, Salt, and Docker are also available. Please see the
  # documentation for more information about their specific syntax and use.
  # config.vm.provision "shell", inline: <<-SHELL
  #   sudo apt-get update
  #   sudo apt-get install -y apache2
  # SHELL
  # cf: https://github.com/mitchellh/vagrant/issues/5590#issuecomment-105886361
  config.vm.provision "shell", inline: "nmcli connection reload; systemctl restart network.service", run: "always"

  config.vm.provision :shell do |shell|
    #initialize puppet
    shell.name = "puppet_initialize"
    shell.path = "provisioning/bootstrap-puppet.sh"
  end

  config.vm.provision :shell do |shell|
    #initialize puppet
    shell.name = "system_initialize"
    shell.inline = "[ ! -d '/tmp/vagrant-puppet' ] && mkdir -p '/tmp/vagrant-puppet' || :;"
  end


  config.vm.provision :puppet do |puppet|
      puppet.manifests_path = "provisioning"
      puppet.manifest_file = "default.pp"
      puppet.module_path = "provisioning/modules"
      puppet.hiera_config_path = "provisioning/hiera.yaml"
      puppet.working_directory = "/vagrant/provisioning/"
      puppet.options = "--verbose --debug"
  end

end
